''' Vogliamo disegnare i dati presenti in un file di testo su un grafico.
    Il file contiene su ciascuna riga, seguiti da 1 virgola e/o 0 o più spazi o accapi, 
    gruppi di 5 valori interi che rappresentano per ciascun dato:
        - larghezza
        - alezza
        - canale R del colore
        - canale G del colore
        - canale B del colore
    Ciascuna riga contiene almeno un gruppo di 5 interi positivi relativi ad un dato da plottare.
    Per ciascun dato dobbiamo disegnare un rettangolo del colore indicato e di dimensioni indicate

    Realizzate la funzione ex2(file_dati, file_png, spaziatura) che:
    - legge i dati dal file file_dati
    - costruisce una immagine in formato PNG e la salva nel file file_png
    - ritorna le dimensioni larghezza,altezza dell'immagine

    L'immagine deve avere sfondo nero e visualizzare tutti i dati come segue:
    - l'argomento spaziatura indica il numero di pixel da usare per il bordo esterno
      e la spaziatura minima in orizzontale tra i rettangoli ed in verticale tra le righe
    - ciascun dato è rappresentato da un rettangolo descritto da una quintupla
    - i dati contenuti su ciascuna riga del file devono essere disegnati, centrati verticalmente, su una riga della immagine
    - i rettangoli devono essere equidistanti orizzontalmente l'uno dall'altro 
        con una distanza minima di 'spaziatura' pixel tra un rettangolo ed il seguente
        in modo che tutti i primi rettangoli si trovino a 'spaziatura' pixel dal bordo sinistro
        e tutti gli ultimi rettangoli di trovino a 'spaziatura' pixel dal bordo destro
        NOTA se la riga contiene un solo rettangolo dovrà essere disegnato centrato in orizzontale
    - ciascuna riga di rettangoli si trova ad una distanza minima di 'spaziatura' pixel in verticale dalla seguente
        NOTA: la distanzprogram01.ita.pya in verticale va calcolata tra i due rettangoli più alti delle due linee consecutive
        Il rettangolo più grosso della prima riga si trova a 'spaziatura' pixel dal bordo superiore
        Il rettangolo più grosso dell'ultima riga si trova a 'spaziatura' pixel dal bordo inferiore
    - l'immagine ha le dimensioni minime possibili, quindi:
        - esiste almeno un rettangolo della prima/ultima riga a 'spaziatura' pixel dal bordo superiore/inferiore
        - esiste almeno una riga che ha il primo ed ultimo rettangolo a 'spaziatura' pixel dal bordo sinistro/destro

    NOTA: nel disegnare i rettangoli arrotondate le coordinate che ottenete all'intero più vicino
'''
import images

def loadRectangles(fileName):
    rectangles = []
    f = open(fileName, encoding='utf-8')
    lines = f.readlines()
    f.close()
    rect = []
    num = ""
    for l in lines:
        for c in l:
            if c.isdigit():
                num += c
            elif num != "":
                rect.append(int(num))
                num = ""
                if len(rect) == 5:
                    rectangles.append(rect)
                    rect = []
    return rectangles

def ex(file_dati, file_png, spaziatura):
    R = loadRectangles(file_dati)
    print(R)

if __name__ == '__main__':
    ex("matrices/example.txt", "matrices/maurizio.png", 10)

